# Record Class AgentMetadata

java.lang.Object
java.lang.Record
com.google.adk.planner.goap.AgentMetadata

Record Components:
  `agentName` - the name of the agent (must match `BaseAgent.name()`)
  `inputKeys` - the state keys this agent reads as inputs
  `outputKey` - the state key this agent produces as output

public record AgentMetadata(String agentName, com.google.common.collect.ImmutableList<String> inputKeys, String outputKey) extends Record
Declares what state keys an agent reads (inputs) and writes (output).

Used by `GoalOrientedPlanner` and `P2PPlanner` for dependency resolution.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AgentMetadata(String agentName, com.google.common.collect.ImmutableList<String> inputKeys, String outputKey)`
  Creates an instance of a `AgentMetadata` record class.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `agentName()`
  Returns the value of the `agentName` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `com.google.common.collect.ImmutableList<String>`
  `inputKeys()`
  Returns the value of the `inputKeys` record component.
  `String`
  `outputKey()`
  Returns the value of the `outputKey` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### AgentMetadata

    public AgentMetadata(String agentName, com.google.common.collect.ImmutableList<String> inputKeys, String outputKey)
    Creates an instance of a `AgentMetadata` record class.
    Parameters:
      `agentName` - the value for the `agentName` record component
      `inputKeys` - the value for the `inputKeys` record component
      `outputKey` - the value for the `outputKey` record component

- ## Method Details

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### agentName

    public String agentName()
    Returns the value of the `agentName` record component.
    Returns:
      the value of the `agentName` record component

  - ### inputKeys

    public com.google.common.collect.ImmutableList<String> inputKeys()
    Returns the value of the `inputKeys` record component.
    Returns:
      the value of the `inputKeys` record component

  - ### outputKey

    public String outputKey()
    Returns the value of the `outputKey` record component.
    Returns:
      the value of the `outputKey` record component